SystemOrganization addCategory: #Nautilus!

!RecentMessageList methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/18/2011 16:14'!
lastClasses: anInteger

	"I return the last anInteger classes modified"
	| result tempList |
	result := OrderedCollection new.
	tempList := self methodReferenceList copy sort: [:a :b | a timeStamp <= b timeStamp].
	
	tempList do: [:method || class |
		result size = anInteger ifTrue: [^result].
		class := method methodClass.
		(result includes: class) ifFalse: [result add: class]].
	^ result! !

StandardWindow subclass: #NautilusWindow
	instanceVariableNames: ''
	classVariableNames: 'Icon'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusWindow methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/18/2011 10:30'!
icon

	^ NautilusUI icon! !

Object subclass: #Nautilus
	instanceVariableNames: 'selectedClass selectedPackage selectedCategory selectedMethod selectedGroup packages classes'
	classVariableNames: 'Groups RecentClasses'
	poolDictionaries: ''
	category: 'Nautilus'!

Nautilus class
	instanceVariableNames: 'maxSize'!

!Nautilus commentStamp: 'BenjaminVanRyseghem 3/17/2011 16:20' prior: 0!
Nautilus new open !

Nautilus class
	instanceVariableNames: 'maxSize'!

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 16:16'!
buildGroupManager

	^ (GroupsManager new) 
		addADynamicGroupSilentlyNamed: 'Most Viewed Classes' 
		model: self 
		selector: #recentClassesElements;
		addADynamicGroupSilentlyNamed: 'Last Modified Classes' 
		model: self 
		selector: #lastModifiedClasses;
		yourself
			! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:15'!
groupsManager

	^ Groups ifNil: [ Groups := self buildGroupManager]! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:15'!
lastModifiedClasses

	^ RecentMessageList uniqueInstance lastClasses: 10! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:45'!
maxSize

	^ maxSize ifNil: [ maxSize := 10]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
maxSize: anInteger

	maxSize := anInteger.
	self recentClasses maxSize: anInteger.! !

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
packages: aCollection

	^ self new packages: aCollection! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
recentClasses

	^ RecentClasses ifNil: [ RecentClasses := HistoryCollection maxSize: self maxSize ]! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 15:40'!
recentClassesElements

	^ self recentClasses elements! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
allClasses

	^ self class environment allClassesAndTraits! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
allPackages

	^ RPackageOrganizer default packages sort: [:a :b | a name <= b name]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 10:02'!
classes
	
	^ classes ifNil: [ classes := self allClasses ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 10:01'!
classes: aCollection

	classes := aCollection! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:07'!
classesInTheSelectedPackage

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil: [:package | 
			(package definedClasses asArray sort: [:a :b | a name <= b name]), (package extendedClasses asArray sort: [:a :b | a name <= b name])]! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 17:11'!
foundExtentionsIn: aClass

	| result |
	result :=  aClass extendingPackages.
	"self haltIf: [result isEmpty not]."
	^ result! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:49'!
groupsManager
	
	^ self class groupsManager! !

!Nautilus methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/7/2011 15:28'!
open

	(self uiClass on: self) open! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
packages

	^ packages ifNil: [self allPackages]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 10:02'!
packages: aCollection

	packages := aCollection.
	self classes: (aCollection gather: [:each | each classes ])! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 09:59'!
packagesUsedByTheSelectedClass

	| result class |
	result := OrderedCollection new.
	class := self selectedClass.
	
	class ifNil: [^{}].
	result add: class package.
	result addAll: (self foundExtentionsIn: class).
	result := result intersection: self packages.
	^ result select:[:each | each notNil]! !

!Nautilus methodsFor: 'accessing' stamp: 'StephaneDucasse 3/17/2011 15:25'!
recentClasses

	^ self class recentClasses! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:50'!
resetGroupsManager

	GroupsManager := nil! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory

	^ selectedCategory! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory: anObject

	selectedCategory := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedClass

	^ selectedClass! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:14'!
selectedClass: anObject

	selectedClass := anObject.
	anObject ifNotNil: [ self recentClasses add: anObject ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:55'!
selectedGroup

	^ selectedGroup! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:48'!
selectedGroup: anObject

	selectedGroup := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod

	^ selectedMethod! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod: anObject

	selectedMethod := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedPackage

	^ selectedPackage! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 14:09'!
selectedPackage: anObject

	selectedPackage := anObject! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:59'!
uiClass

	^ NautilusUI! !

Object subclass: #NautilusUI
	instanceVariableNames: 'model window methodsTree selectedMethod selectedCategory showCategories showHierarchy hierarchyClass cachedHierarchy showGroups showInstance showComment sourceTextArea showPackages firstColumn secondColumn'
	classVariableNames: 'Icon'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusUI commentStamp: 'BenjaminVanRyseghem 3/17/2011 17:06' prior: 0!
I am browser in memory of Jules Vernes
I'm working on RPackage!

!NautilusUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/17/2011 17:51'!
buildIcon

	| bitmap |
	bitmap :=  (Bitmap new: 256) copyFromByteArray:   #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 249 235 15 254 248 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 183 102 33 13 162 147 126 14 199 176 153 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 143 187 142 101 94 197 140 89 0 0 0 0 208 181 135 93 108 190 134 85 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 144 159 121 84 174 168 127 90 119 181 140 104 194 182 128 81 24 207 148 99 4 252 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 159 170 119 70 255 200 124 58 253 189 122 63 60 148 118 91 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 199 157 91 59 255 222 129 64 255 201 118 48 178 152 100 49 73 138 112 54 106 168 135 62 167 206 169 100 193 191 158 105 115 172 143 97 0 0 0 0 5 155 136 98 55 204 190 157 10 236 223 187 0 0 0 0 21 105 87 68 91 162 123 78 240 187 126 60 255 212 131 43 253 227 148 48 255 218 157 63 255 233 175 78 255 235 176 64 255 224 167 68 255 232 171 81 255 216 168 74 109 181 145 85 21 154 136 98 245 194 174 137 33 211 209 190 81 172 145 107 241 194 152 81 255 207 158 80 255 243 176 64 254 246 176 67 254 208 141 49 255 221 156 81 255 200 123 54 255 209 137 56 255 187 124 56 254 204 128 48 255 248 183 62 230 171 125 65 0 0 0 0 198 196 161 122 135 198 161 130 238 191 139 90 255 227 158 63 254 234 165 51 254 244 172 65 255 227 160 65 254 170 105 26 255 209 144 65 254 185 117 40 253 213 143 55 252 221 143 58 248 238 144 58 255 223 134 39 250 163 97 51 20 231 255 255 185 186 137 106 255 181 122 80 255 162 85 36 255 221 124 53 255 234 154 50 255 234 170 61 255 232 168 69 255 220 149 53 255 238 159 56 255 241 163 59 255 231 158 59 255 226 151 64 255 198 120 54 215 166 91 43 57 133 68 38 13 210 220 210 83 199 158 129 209 203 160 125 129 184 139 102 235 161 83 47 255 190 102 41 255 203 112 40 255 208 117 47 253 213 121 50 251 208 122 55 222 185 106 44 175 159 100 50 139 141 103 65 53 156 105 65 9 99 69 79 0 0 0 0 0 0 0 0 0 0 0 0 143 155 129 114 0 0 0 0 10 138 135 170 65 108 49 22 87 138 77 48 93 129 70 41 45 93 34 6 26 68 32 26 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 197 179 174 0 0 0 0 93 197 180 176 4 202 182 170 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 180 88 18 2 146 92 49 1 128 100 73 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].
	^ Form extent: 16@16 depth: 32 bits: bitmap! !

!NautilusUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/17/2011 17:55'!
icon 

	^ Icon ifNil: [Icon := self buildIcon]! !

!NautilusUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
on: aNautilus

	^ self new model: aNautilus! !

!NautilusUI class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/17/2011 17:48'!
resetIcon

	Icon := nil! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addAll: aWindow
			
			
	aWindow
		addMorph: (self buildFirstColumn: aWindow)
		frame: (0@0 corner: 0.33@0.5).		
				
	aWindow
		addMorph: (self buildSecondColumn: aWindow)
		frame: (0.33@0 corner: 0.66@0.5).

	aWindow 
		addMorph: (self buildMethodsTree)
		frame: (0.66@0 corner: 1@0.5).
	
	aWindow
		addMorph: (self buildCodePane)
		frame: (0@0.5 corner: 1@1)! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
addClassInAGroup

	(DialogGroupAdder new
		groups:	self groupsManager;
		elementToAdd: self selectedClass)
		open! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
addPackageAsGroup

	| package |
	package := self selectedPackage.
	^ self groupsManager	
			addAStaticGroupSilentlyNamed: package name 
			with: package classes! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/18/2011 14:44'!
addPackageAsGroupAndBrowse

	self addPackageAsGroup
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addSubclassesOf: aClass in: result withIndex: index

	(aClass subclasses sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addSubclassesOf: aClass in: result withIndex: index fromRestrictedCollection: aCollection

	| classes |
	
	classes := aClass subclasses intersection: aCollection.
	(classes sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1 fromRestrictedCollection: aCollection]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
arrowKey: aCharacter from: aPluggableListMorph 
	aCharacter == $b
		ifTrue: [
			self selectedClass ifNotNil: [:class | class browse]]! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildCodePane

	sourceTextArea := PluggableTextMorph
				on: self
				text: #sourceCode
				accept: #compileSource: 
				readSelection: nil
				menu: #msgPaneMenu:shifted:.
				
	^ sourceTextArea! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildCommentButton

	^ (PluggableButtonMorph
			on: self 
			getState: #commentButtonState
			action: #commentButtonAction
			label: #commentButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:54'!
buildFirstColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ firstColumn := GroupboxMorph new
			addContentMorph: self buildList;
			addContentMorph: (aWindow newRow: {self buildToogleButton. self buildGroupsButton});
			label: self labelText;
			hResizing: #spaceFill;
			vResizing: #spaceFill
			! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:39'!
buildGroupHierarchyFor: aGroup

	| result tmp index |
	result := OrderedCollection new.
	aGroup ifNil: [^ result ].
	((self rootsOfGroup: aGroup) asArray sort: [:a :b | a name <= b name ]) do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: (aGroup elements)].
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildGroupsButton

	^ (PluggableButtonMorph
			on: self 
			getState: #groupsButtonState
			action: #groupsButtonAction
			label: #groupsButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildHierarchyFor: aClass

	| result tmp index |
	
	aClass ifNil: [^ {}].
	result := OrderedCollection new.
	tmp := aClass withAllSuperclasses reverse.
	1 to: tmp size do: [:i | result add: (tmp at: i) -> (i-1)].

	index := (tmp size -1).
	self addSubclassesOf: aClass in: result withIndex: index + 1.
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildInstanceButton

	^ (PluggableButtonMorph
			on: self 
			getState: #instanceButtonState
			action: #instanceButtonAction
			label: #instanceButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 17:04'!
buildList

	| list |
	list := PluggableListMorph
				on: self
				list: #getList
				selected: #selected
				changeSelected: #selected:
				menu: #menu:shifted:.
	list doubleClickSelector: #doubleClick.
	list wrapSelector: #listWrapper:.
	list hResizing: #spaceFill.
	list vResizing: #spaceFill.
	^ list! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 17:03'!
buildList2

	| list2 |
	list2 := PluggableListMorph
				on: self
				list: #getList2
				selected: #selected2
				changeSelected: #selected2:
				menu: #menu2:shifted:.
	list2 wrapSelector: #listWrapper2:.
	list2 hResizing: #spaceFill.
	list2 vResizing: #spaceFill.
	^ list2! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildMethodsTree

	methodsTree := SwitchableCategoriesTreeWithLabel
							on: self
							rootsSelector: #roots
							categoriesLabelSelector: #categoriesLabel
							elementsLabelSelector: #methodsLabel
							categoriesButtonLabelSelector: #categoriesButtonLabel
							elementsButtonLabelSelector: #methodsButtonLabel
							getSwitchSelector: #getSwitch
							setSwitchSelector: #setSwitch:
							getSelectedElementSelector: #selectedMethod
							setSelectedElementSelector: #selectedMethod:
							getSelectedCategorySelector: #selectedCategory
							setSelectedCategorySelector: #selectedCategory:
							setCategoryWrapperSelector: #categoryWrapper:
							setElementWrapperSelector: #methodWrapper:.

	^ methodsTree build! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildPackageHierarchyFor: aPackage

	| result tmp index |
	result := OrderedCollection new.
	((self rootsOf: aPackage) asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: aPackage definedClasses].
	(aPackage extendedClasses  asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0)].
	^ result! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildPackagesClassesColumn: aWindow


	"container := PanelMorph new."
	"to fix in order to avoid the resize"
	
	"^ aWindow newColumn: {
			(aWindow newRow: {
				self buildFirstColumn: aWindow.
				self buildSecondColumn: aWindow})
				hResizing: #spaceFill; vResizing: #spaceFill.
			self buildToogleButton}"! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildRootsFromClass: aClass

	| result |
	result := Dictionary new.
	aClass ifNil: [^result].
	
	aClass methodDict values do: [:method || category |
		category := method category.
		(result at: category ifAbsent: [result at: category put: (SortedCollection sortBlock: [:a :b | a selector <= b selector])]).
		(result at: category) add: method].
	^ result! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:57'!
buildSecondColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph2.
		self buildList2.
		aWindow newRow: {self buildInstanceButton. self buildCommentButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ secondColumn := GroupboxMorph new
			addContentMorph: self buildList2;
			addContentMorph: (aWindow newRow: {self buildInstanceButton. self buildCommentButton});
			label: self labelText2;
			hResizing: #spaceFill;
			vResizing: #spaceFill! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildTabbedNameOf: anElement
			
	| tab result assoc |
	
	tab := '   '.
	result := ''.
	assoc := cachedHierarchy detect: [:each | each key == anElement ] ifNone: [''->0].
	1 to: assoc value do: [:i | result := tab, result].
	^ self selectedPackage 
		ifNil: [result, anElement name]
		ifNotNil: [:package | 
			(package extendedClasses includes: anElement)
				ifTrue: [ result , '*', anElement name ]
				ifFalse: [ result, anElement name ]]! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildToogleButton

	^ (PluggableButtonMorph
			on: self 
			getState: #toogleButtonState
			action: #toogleButtonAction
			label: #toogleButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoriesButtonLabel

	^ 'Switch to methods'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoriesLabel

	^ self showInstance
		ifTrue: ['Categories:']
		ifFalse: ['Class categories:']! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoryWrapper: anItem

	^ anItem! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:58'!
changedLabels

	firstColumn label: self labelText.
	secondColumn label: self labelText2.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
classLabel

	^'Class'! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
classesMenu: aMenu shifted: b
		
	self selectedClass notNil 
		ifTrue: [
			self showGroups
				ifTrue: [
					aMenu
						add: 'Remove from Group (x)' translated
						target: self
						selector: #removeClassFromGroup
					]
				ifFalse: [
					aMenu
						add: 'Add in Group (e)' translated
						target: self
						selector: #addClassInAGroup]]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonAction

	self toogleShowComment! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonLabel

	^ self commentLabel! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonState

	^ self showComment! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentLabel

	^ 'Show Comments'! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
defaultClassDescriptor

	| string |
	string := 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: '''.
	^ self selectedPackage
		ifNil: [string, '''' ]
		ifNotNil: [:package | string, package name, '''' ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
doubleClick

	self ifPackages: [ self doubleClickOnPackage ] ifClasses: [ self doubleClickOnClass ]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
doubleClickOnClass

	self toogleShowHierarchy! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
doubleClickOnPackage

	(self model class packages: {self selectedPackage}) open! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
foundPackageOf: aClass

	aClass ifNil: [^ nil].
	^ aClass package! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassHierarchy

	self hierarchyClass
		ifNil: [^self getClassesList].

	^ cachedHierarchy collect: [:each | each key ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassHierarchy2

	self showPackages ifFalse: [self halt].
	^ self selectedPackage
		ifNil: [{}]
		ifNotNil:[:package |
			cachedHierarchy := self buildPackageHierarchyFor: package.
			cachedHierarchy collect: [:each | each key ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassesList

	^ self model classes! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassesList2

	^ self model packagesUsedByTheSelectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getGroupHierarchy

	^ self selectedGroup 
		ifNil: [^ {}]
		ifNotNil: [:group |
			cachedHierarchy := self buildGroupHierarchyFor: group.
			cachedHierarchy collect: [:assoc | assoc key] ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
getGroupsKeyList

	^ self groupsManager groups! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
getGroupsValuesList

	^ self groupsManager at: self selectedGroup ifAbsent: [{}]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getList
	
	^
	self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					self selectedClass
						ifNil: [ 
							cachedHierarchy
								ifNil: [ self getClassesList ]
								ifNotNil: [:col | col collect: [:assoc | assoc key]]]
						ifNotNil: [:class | 
							self showHierarchy
								ifTrue: [ self getClassHierarchy ]
								ifFalse:[ {class} ]]]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getList2
	
	^ self 
		ifGroups: [
			self showHierarchy
				ifTrue: [ self getGroupHierarchy ]
				ifFalse: [ self getGroupsValuesList ]]
		ifNot: [
			 self 
				ifPackages: [
					self showHierarchy
						ifTrue: [ self getClassHierarchy2 ]
						ifFalse: [ self getPackagesList2 ]]
				ifClasses: [self getClassesList2 ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getPackagesList

	^ self model packages! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getPackagesList2

	^ self model classesInTheSelectedPackage! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getSwitch 

	^ showCategories ifNil: [showCategories := true]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonAction

	self toogleShowGroups! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonLabel

	^ self groupsLabel! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonState

	^ self showGroups! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsLabel

	^ 'Show Groups'! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:52'!
groupsManager

	^ self model groupsManager! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/18/2011 15:48'!
groupsMenu: aMenu shifted: b
	
	(self selectedGroup isNil or: [self selectedGroup isReadOnly])
		ifFalse: [
			aMenu
				add: 'Rename (r)' translated
				target: self
				selector: #renameAGroup.
				
			aMenu
				add: 'Remove (x)' translated
				target: self
				selector: #removeAGroup]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
hierarchyClass

	^ hierarchyClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
hierarchyClass: aClass

	hierarchyClass := aClass.
	cachedHierarchy := self buildHierarchyFor: aClass.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
ifGroups: aBlock ifNot: anotherBlock

	^self showGroups
			ifTrue: aBlock
			ifFalse: anotherBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
ifPackages: pBlock ifClasses: cBlock

	^ self showPackages
		ifTrue: pBlock
		ifFalse: cBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
initialize

	super initialize.
	cachedHierarchy := OrderedCollection new.! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceButtonAction

	self toogleShowInstance! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceButtonLabel

	^ self showInstance
		ifTrue: [ self instanceLabel ]
		ifFalse: [ self classLabel ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceButtonState

	^ self showInstance not! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceLabel

	^'Instance'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
labelText

	^ self ifPackages: ['Packages:'] ifClasses: ['Classes:']! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
labelText2

	^ self ifPackages: ['Classes:'] ifClasses: ['Packages:']! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
listWrapper2: anElement

	^ self 
		ifPackages:	[
			"anElement is a Class"
			self showHierarchy
				ifTrue: [ self buildTabbedNameOf: anElement ]
				ifFalse: [
					(self selectedPackage extendedClasses includes: anElement)
						ifTrue: ['*', anElement name]
						ifFalse: [anElement name]]]
		ifClasses: [
			"anElement is a RPackage"
			(self selectedClass package == anElement)
				ifTrue: [anElement name]
				ifFalse: ['*', anElement name]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/18/2011 14:47'!
listWrapper: anElement

	anElement = 0 ifTrue: [^''].
	^ self 
		ifGroups: [ anElement name ]
		ifNot: [ self 
				ifPackages: [ anElement name  ] 
				ifClasses: [ 
					self showHierarchy
						ifTrue: [ self buildTabbedNameOf: anElement ]
						ifFalse:[ anElement name ]]]! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
menu2: aMenu shifted: b 

	self 
		ifPackages: [ self classesMenu: aMenu shifted: b ]
		ifClasses: [ 
			self showGroups
				ifTrue: [ self groupsMenu: aMenu shifted: b ]
				ifFalse: [ self packagesMenu: aMenu shifted: b ]].
	^ aMenu! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
menu: aMenu shifted: b 

	self 
		ifPackages: [ 
			self showGroups
				ifTrue: [ self groupsMenu: aMenu shifted: b ]
				ifFalse: [ self packagesMenu: aMenu shifted: b ]]
		ifClasses: [ self classesMenu: aMenu shifted: b ].
	^ aMenu! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
methodWrapper: anItem

	^ anItem selector! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
methodsButtonLabel

	^ 'Switch to categories'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
methodsLabel

	^ self showInstance
		ifTrue: ['Methods']
		ifFalse: ['Class methods']! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
model

	^ model! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
model: anObject

	model := anObject! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 17:43'!
open

	window := NautilusWindow new model: self.
	self addAll: window.
	window openInWorld.
	window title: self title! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
packagesMenu: aMenu shifted: b

	aMenu
		add: 'Find Class... (f)'
		target: self
		selector: #openFindAClass.
		
	aMenu addLine.	
	aMenu
		add: 'Add as Group & Browse (g)' translated
		target: self
		selector: #addPackageAsGroupAndBrowse.
		
	aMenu
		add: 'Add as Group (G)' translated
		target: self
		selector: #addPackageAsGroup.! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
removeAGroup

	self groupsManager removeAGroup: self selectedGroup.
	self selectedGroup: nil.
	self changed: #getList.
	self changed: #getList2! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
removeClassFromGroup

	self groupsManager remove: self selectedClass from: self selectedGroup.
	self changed: #getList2.! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/18/2011 15:03'!
renameAGroup

	| newName |
	self groupsManager renameAGroup: self selectedGroup.
	self changed: #getList.
	self changed: #getLIst2! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/18/2011 16:19'!
roots

	"^ self showInstance
		ifTrue: [ self buildRootsFromClass: self selectedClass]
		ifFalse: [ self buildRootsFromClassSide: self selectedClass ]."
		
^ self buildRootsFromClass: self selectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
rootsOf: aPackage

	^ aPackage definedClasses select: [:each |
		(aPackage definedClasses includes: each superclass)  not]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:38'!
rootsOfGroup: aGroup

	| classes |
	classes := aGroup elements.
	^ classes select: [:each |
		(classes includes: each superclass)  not]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selected

	| item |
	item :=  self 
				ifGroups: [ self selectedGroup ]
				ifNot: [ self ifPackages: [ self selectedPackage ] ifClasses: [ self selectedClass ]].
				
	^self getList indexOf: item.
	"^ selected ifNil: [selected := 0]"! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 16:20'!
selected2

	| item |
	item :=  self ifPackages: [ self selectedClass ] ifClasses: [ self selectedPackage ].
	self showInstance ifFalse: [ item ifNotNil: [item := item soleInstance]].
	^self getList2 indexOf: item.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 16:22'!
selected2: anInteger

	| selection |
	selection := self getList2 at: anInteger ifAbsent: [nil].
	self 
		ifPackages: [ 
			self showInstance ifFalse: [selection ifNotNil: [selection := selection class]].
			self selectedClass: selection ] 
		ifClasses: [	self selectedPackage: selection ].
	self changed: #selected2.
	anInteger = 0 ifTrue: [^self].
	self changed: #getList.
	self changed: #getList2.
	self changed: #selected.
	! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selected: anInteger

	| selection |
	selection := self getList at: anInteger ifAbsent: [nil].
	self 
		ifGroups: [ self selectedGroup: selection ]
		ifNot: [ self ifPackages: [ self selectedPackage: selection] ifClasses: [ self selectedClass: selection] ].

	self changed: #selected.
	self changed: #getList2! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedCategory

	^ selectedCategory! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedCategory: anObject

	selectedCategory := anObject! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedClass

	^ self model selectedClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedClass: aClass 

	self model selectedClass: aClass.
	self showGroups ifTrue: [self selectedPackage: (self foundPackageOf: aClass) ].
	self showPackages
		ifFalse: [ 
			self selectedPackage: (self foundPackageOf: aClass).
			self changed: #getList2].
	self selectedMethod: nil.
	self update.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedClassComments

	^ self selectedClass comment! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedClassDescription

	^ self selectedClass definition! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedGroup
	
	^ self model selectedGroup! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:42'!
selectedGroup: anObject

	self model selectedGroup: anObject! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethod
	^ selectedMethod! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethod: aCompiledMethod 

	selectedMethod := aCompiledMethod.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethodComments

	^ self selectedMethod comment! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethodSource

	^ self selectedMethod getSource! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedPackage

	^ self model selectedPackage! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedPackage: aPackage

	self model selectedPackage: aPackage.
	(self showPackages and: [self selectedClass notNil and: [self selectedClass package ~= aPackage]])
		ifTrue: [ self selectedClass: nil ].
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
setSwitch: aBoolean

	showCategories := aBoolean! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showComment

	^ showComment ifNil: [showComment := false.]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showComment: aBoolean

	showComment := aBoolean.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showGroups

	^ showGroups ifNil: [ showGroups := false].! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showGroups: aBoolean

	showGroups := aBoolean.
	self changed: #getList.
	self changed: #getList2.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showHierarchy

	^ showHierarchy ifNil: [showHierarchy := true]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showHierarchy: aBoolean

	showHierarchy := aBoolean.
	aBoolean 
		ifTrue: [self hierarchyClass: self selectedClass]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showInstance

	^ showInstance ifNil: [ showInstance := true ].! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 16:24'!
showInstance: aBoolean

	showInstance := aBoolean.
	self selectedClass 
		ifNotNil: [:class | 
			aBoolean 
				ifTrue: [self selectedClass: class soleInstance]
				ifFalse: [self selectedClass: class class]].
	methodsTree update.
	self changed: #instanceButtonLabel! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showPackages

	^ showPackages ifNil: [showPackages := true]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
showPackages: aBoolean

	showPackages := aBoolean.
	aBoolean ifFalse: [
		self hierarchyClass: self selectedClass].
	self showGroups
		ifTrue: [self showGroups: false].
	self changed: #getList.
	self changed: #getList2.
	self changed: #toogleButtonLabel.
	self changedLabels.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
sourceCode

	^self selectedClass isNil
		ifTrue: [self defaultClassDescriptor]
		ifFalse:[
			self selectedMethod isNil
				ifTrue: [
					self showComment
						ifTrue: [self selectedClassComments]
						ifFalse: [self selectedClassDescription]]
				ifFalse: [
					self showComment
						ifTrue: [self selectedMethodComments]
						ifFalse: [self selectedMethodSource]]].
		! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 17:41'!
taskbarIcon

	^ self class icon! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
title

	^'Nautilus'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 17:00'!
toogleButtonAction

	self selectedClass ifNil: [^self].
	self toogleShowPackages! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleButtonLabel

	^ 'Hierarchy'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleButtonState

	^ false! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowComment

	self showComment: self showComment not! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowGroups

	self showGroups: self showGroups not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowHierarchy

	self showHierarchy: self showHierarchy not.
	self changed: #getList.
	self changed: #getList2.
! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowInstance

	self showInstance: self showInstance not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowPackages

	self showPackages: self showPackages not.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
update

	methodsTree ifNotNil: [:tree | tree update]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
window

	^ window! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
window: anObject

	window := anObject! !

!Trait methodsFor: '*Nautilus' stamp: 'BenjaminVanRysghem 3/17/2011 16:32'!
superclass
	" use to be polymorphic with classes "

	^ nil! !
